#---- Setup
    # Install
    function Install-Chocolatey
    {
        if (!(get-command choco.exe -ErrorAction SilentlyContinue))
            {
                Set-ExecutionPolicy Bypass -Scope Process -Force; 
                [System.Net.ServicePointManager]::SecurityProtocol = [System.Net.ServicePointManager]::SecurityProtocol -bor 3072;
                iex ((New-Object System.Net.WebClient).DownloadString('https://chocolatey.org/install.ps1'))
            }
    }

#---- Get-Help:

# !!! Most Important PowerShell Command !!!
    $command = Get-ChildItem
    get-help $command -Examples

#---- Get-Command:

    # Display all commands ending in the NOUN 'process'
        Get-Command *process | Select-Object -First 10

    # Display all commands ending in the VERB 'set'
        Get-Command wait* | Select-Object -First 10

#---- Get-Content

#---- Get-ChildItem:

    # Recursive ls and show hidden files
        Get-ChildItem -Recurse -Force
        Get-ChildItem -attributes hidden

#---- Get-PSDrive: Gets the PowerShell

    <#
        The Get-PSDrive cmdlet gets the drives in the current session. You can get a particular drive or all drives in the session.
        This cmdlet gets the following types of drives:
        - Windows logical drives on the computer, including drives mapped to network shares.
        - Drives exposed by Windows PowerShell providers (such as the Certificate:, Function:, and Alias: drives) 
            and the HKLM: and HKCU: drives that are exposed by the Windows PowerShell Registry provider.
        - Session-specified temporary drives and persistent mapped network drives that you create by using the New-PSDrive cmdlet.
    #>
    Get-PSDrive
    # View Alias
    Get-ChildItem Alias:\
    # View Functions
    Get-ChildItem Function:\
    # View Registry Keys
    Get-ChildItem HKCU:\

#---- Starting and Killing processes

    Start-Process calc
    (Get-Process calculator*).kill()

#---- In order to run scripts in PowerShell
    
    Get-ExecutionPolicy
    Set-ExecutionPolicy -ExecutionPolicy Unrestricted -Scope CurrentUser
