#!/bin/bash
if : ; then
# File:         stack.sh
# Name:         Kevin Crotty
# Date:         27 Apr 2019
# Desc:         Demonstrate the relationship between the stack and assembly
# Usage:        ./stack.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e ${BGreen} \#<Some Comment> \n ${BRed} "<some command>" ${NC}
# <some command>
fi

function display {

    echo -e "${BPurple}Terminal @ /dev/pts/0${NC}"
    echo -e "${BBlue}${prompt2}${BRed}${first}${BGreen}${prev}${NC}"
    echo -e ""
    echo -e "${BBlue}${prompt1}${BRed}${second}"
    echo -e ""
    echo -e "${BGreen}--------------------------------------------------------------------------------------------------------------------------"
    echo -e "${BPurple}Terminal @ /dev/pts/1 running: ${BRed} watch -n0 'ps --forest -elf | grep -v pts/2 | grep pts/1'\n${NC}"
    echo -e "Every 0.1s: ps --forest -o pid,ppid,euser,ruser,tname,comm | grep -v pts/1 | grep pts/0    Debian-Buster: Thu Jul 18 20:49\n"
    echo -e "${BGreen}PID  PPID EUSER    RUSER    TTY      COMMAND${NC}"
    echo -e "${pid_1} ${ppid_1} ${main_1}      ${comm_1}"
    echo -e "${pid_2} ${ppid_2} ${main_2}      ${comm_2}"
    echo -e "${pid_3} ${ppid_3} ${main_3}      ${comm_3}"
    echo -e "${pid_4} ${ppid_4} ${main_4}      ${comm_4}"
    echo -e "${pid_5} ${ppid_5} ${main_5}      ${comm_5}"
    echo -e "${pid_6} ${ppid_6} ${main_6}      ${comm_6}"
    echo -e "${pid_7} ${ppid_7} ${main_7}      ${comm_7}"
    echo -e "${pid_8} ${ppid_8} ${main_8}      ${comm_8}"
    echo -e "${pid_9} ${ppid_9} ${main_9}      ${comm_9}"
    echo -e "${pid_10} ${ppid_10} ${main_10}      ${comm_10}"
    echo -e "${pid_11} ${ppid_11} ${main_11}      ${comm_11}"
    echo -e "${pid_12} ${ppid_12} ${main_12}      ${comm_12}"
    echo -e "${pid_13} ${ppid_13} ${main_13}      ${comm_13}"
    echo -e "${pid_14} ${ppid_14} ${main_14}      ${comm_14}"


}

function proceed {

    clear && display
    test -n "$1" &&  exit
    read -p 'Press "x" to exit, or any key to continue : ' ans
    [ $ans = x ] && exit 0

}

reset
while :
do

    prompt1='zeus@host:~\$ '
    prompt2=
    main_1='root     crotty   pts/0'
    pid_1=1802
    ppid_1=1801
    comm_1=su
    proceed

    prompt1='zeus@host:~\$ '
    prompt2=
    first=
    second=bash
    main_2='root     root     pts/0'
    pid_2=1803
    ppid_2=1802
    comm_2='  \_ bash'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    prev=' <-- Previous Command'
    first=bash
    second=sh
    main_3='root     root     pts/0'
    pid_3=1804
    ppid_3=1803
    comm_3='      \_ sh'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    first=sh
    second=bash
    main_4='root     root     pts/0'
    pid_4=1805
    ppid_4=1804
    comm_4='          \_ bash'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    first=bash
    second=exit
    main_4=
    pid_4=
    ppid_4=
    comm_4=
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    first=exit
    second=exit
    main_3=
    pid_3=
    ppid_3=
    comm_3=
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    prev=' <-- Previous Command'
    first=exit
    second=sh
    main_3='root     root     pts/0'
    pid_3=1804
    ppid_3=1803
    comm_3='      \_ sh'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    prev=' <-- Previous Command'
    first=sh
    second='exec bash'
    main_3='root     root     pts/0'
    pid_3=1804
    ppid_3=1803
    comm_3='      \_ bash'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    first='exec bash'
    second=sh
    main_4='root     root     pts/0'
    pid_4=1805
    ppid_4=1804
    comm_4='          \_ sh'
    proceed

    prompt1='zeus@host:~\$ '
    prompt2='zeus@host:~\$ '
    first='sh'
    second='exec bash'
    main_4='root     root     pts/0'
    pid_4=1805
    ppid_4=1804
    comm_4='          \_ bash'
    proceed done


done

echo && echo
