#!/bin/bash
if : ; then
# File:         arrays.sh
# Name:         Kevin Crotty
# Date:         31 Mar 2019
# Desc:         Arrays in Bash
# Usage:        ./arrays.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

reset

echo -e "${BGreen}\n# \${arr[*]}     All of the items in the array${NC}"
echo -e "${BGreen}# \${!arr[*]}    All of the indexes in the array${NC}"
echo -e "${BGreen}# \${#arr[*]}    Number of the items in the array${NC}"
echo -e "${BGreen}# \${#arr[0]}    Length of item zero${NC}"

colorComment "# Populate Arrays"
colorCommand "color=(\"yellow\" \"orange\" \"red\" \"purple\")"
colorCommand "fruit=(\"banana\" \"orange\" \"apple\" \"grapes\")"

colorComment "# Count the number of indexes in the array"
colorCommand "fruit_count=\${#fruit[*]}"

colorComment "# For loop iterating through both arrays"
colorCommand "for ((x=0; x<\${fruit_count}; x++)); "
colorCommand "do "
colorCommand "echo \"Fruit: \${fruit[\${x}]} Color: \${color[\${x}]}\"; "
colorCommand "done"

echo -e "Fruit: banana Color: yellow"
echo -e "Fruit: orange Color: orange"
echo -e "Fruit: apple Color: red"
echo -e "Fruit: grapes Color: purple\n\n\n"
