#!/bin/bash

# --- COLOR VARIABLES AND FUNCTIONS --- #
    export NC='\e[0m'               # Text Reset
    export BBlack='\e[1;30m'        # Black
    export BRed='\e[1;31m'          # Red
    export BGreen='\e[1;32m'        # Green
    export BYellow='\e[1;33m'       # Yellow
    export BBlue='\e[1;34m'         # Blue
    export BPurple='\e[1;35m'       # Purple
    export BCyan='\e[1;36m'         # Cyan
    export BWhite='\e[1;37m'        # White
    export NC='\e[0m'               # Text Reset
    export Black='\e[0;30m'         # Black
    export Red='\e[0;31m'           # Red
    export Green='\e[0;32m'         # Green
    export Yellow='\e[0;33m'        # Yellow
    export Blue='\e[0;34m'          # Blue
    export Purple='\e[0;35m'        # Purple
    export Cyan='\e[0;36m'          # Cyan
    export White='\e[0;37m'         # White

    function comm { echo -e "${BGreen}${1}${NC}"
    }
    function cli { echo -e "${Red}# ${1}${NC}"
    }
    function label { echo -e "${BBlue}${1}${NC}"
    }
    function output { echo -e "${NC}${1}\n"
    }

comm '# Read/Write for Owner, Read for Group and Others'
cli "chmod 644 test && ls -l"
output "-rw-r--r-- 1 root root 0 Apr 28 22:42 test"
comm '# Read/Write for Owner only'
cli "chmod 600 test && ls -l"
output "-rw------- 1 root root 0 Apr 28 22:42 test"
comm '#  All perms for Owner, Read and Execute for Group and Others'
cli "chmod 755 test && ls -l"
output "-rwxr-xr-x 1 root root 0 Apr 28 22:42 test"
comm '# Read/Write/Execute for Owner only'
cli "chmod 700 test && ls -l"
output "-rwx------ 1 root root 0 Apr 28 22:42 test"
comm '# Same as 644'
cli "chmod u=rw,go=r test && ls -l"
output "-rw-r--r-- 1 root root 0 Apr 28 22:42 test"
comm '# Same as 755'
cli "chmod ugo=,u+rwx,go+rx test && ls -l"
output "-rwxr-xr-x 1 root root 0 Apr 28 22:42 test"
comm '# Sets only the suid bit'
cli "chmod ${Cyan}4${NC}644 test && ls -l"
output "-rw${Cyan}S${NC}r--r-- 1 root root 0 Apr 28 22:42 test"
comm '# Sets the suid and guid bit'
cli "chmod ${Cyan}6${NC}755 test && ls -l"
output "-rw${Cyan}s${NC}r-${Cyan}s${NC}r-x 1 root root 0 Apr 28 22:42 test"
comm '# Sets the sticky bit'
cli "chmod ${Cyan}1${NC}645 test && ls -l"
output "-rw-r--r-${Cyan}t${NC} 1 root root 0 Apr 28 22:42 test"
