#!/bin/bash
if : ; then
# File:         sed.sh
# Name:         Kevin Crotty
# Date:         1 Apr 2019
# Desc:         Sed Basics
# Usage:        ./sed.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export Blue='\e[0;34m'          # Blue
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

fi
reset

echo -e "${Blue}\n--Original Text--
This is line 1 with random pattern 1YelkhvAFy
This is line 2 with random pattern ZGzfg4L+Xy
This is line 3 with random pattern wsN98khUCN
This is line 4 with random pattern PWjEkTjlXB
This is line 5 with random pattern 9lj2eYjO6w
This is line 6 with random pattern DDq1rCb/Eh
This is line 7 with random pattern o3EnthMICd
This is line 8 with random pattern G7m/JmOseu
This is line 9 with random pattern 4//CYfVMD7
--End Text--\n"


echo -e "\n${BGreen}# Sub the first instance of the pattern 'line' with the pattern 'sentence'"
echo -e "${BRed}sed 's/line/sentence/' \$file | head -n3"
echo -e "${NC}This is sentence 1 with random pattern 1YelkhvAFy
This is sentence 2 with random pattern ZGzfg4L+Xy
This is sentence 3 with random pattern wsN98khUCN"

echo -e "\n${BGreen}# Sub the first instance of the pattern 'i' with the pattern '7'"
echo -e "${BRed}sed 's/i/7/' \$file | head -n3"
echo -e "${NC}Th7s is line 1 with random pattern 1YelkhvAFy
Th7s is line 2 with random pattern ZGzfg4L+Xy
Th7s is line 3 with random pattern wsN98khUCN"

echo -e "\n${BGreen}# Sub ${BCyan}all${BGreen} instances of the pattern 'i' with the pattern '7'"
echo -e "${BRed}sed 's/i/7/${BCyan}g${BRed}' \$file | head -n3"
echo -e "${NC}Th7s 7s l7ne 1 w7th random pattern 1YelkhvAFy
Th7s 7s l7ne 2 w7th random pattern ZGzfg4L+Xy
Th7s 7s l7ne 3 w7th random pattern wsN98khUCN"

echo -e "\n${BGreen}# Sub the pattern 'random' with the pattern 'RANDOM' Only on line ${BCyan}3"
echo -e "${BRed}sed '${BCyan}3${BRed} s/random/RANDOM/' \$file | head -n3"
echo -e "${NC}This is line 1 with random pattern 1YelkhvAFy
This is line 2 with random pattern ZGzfg4L+Xy
This is line ${BCyan}3${NC} with ${BCyan}RANDOM${NC} pattern wsN98khUCN"

echo -e "\n${BGreen}# Sub the  pattern 'line' with the pattern 'LINE' on the lines matching the pattern ${BCyan}'line 2'"
echo -e "${BRed}sed '/${BCyan}line 2${BRed}/s/line/LINE/' \$file | head -n3"
echo -e "${NC}This is line 1 with random pattern 1YelkhvAFy
This is ${BCyan}LINE 2${NC} with random pattern ZGzfg4L+Xy
This is line 3 with random pattern wsN98khUCN"

echo -e "\n${BGreen}#  Sub the all instances of the pattern '/' with the pattern '//'"
echo -e "${BGreen}#+ NOTE: Using colons as delimeters since we're actually replacing the slashes"
echo -e "${BRed}echo $PWD | sed 's${BCyan}:${BRed}/${BCyan}:${BRed}//${BCyan}:${BRed}g'"
echo -e "${NC}//repo/os.public.cctc//os//modules//003_linux_essentials//examples//linux_essentials\n\n"
