<#
.SYNOPSIS
    Display Control Flow Examples in Powershell
.DESCRIPTION
.EXAMPLE
.INPUTS
.OUTPUTS
.NOTES
#>

# Function to colorize text. Acceptable Colors (green, red, blue, magenta)
function color($st, $co)
{
    Write-Host $st -ForegroundColor $co
}

# Using this will in effect pause the script waiting for any input to continue to the next example
function continue
{
   $IGNORE = Read-Host "continue..."
}
# ------------------------------------------------------------------------------------------------#


# Show all files with Alternate Data Streams
    Get-ChildItem -recurse | % { Get-Item $_.FullName -stream * } | where stream -ne ':$Data'

# MD5sum in PS
    Get-FileHash C:\Windows\System32\drivers\etc -Algorithm MD5





#region Alternate Data Streams
dir file.txt
type file.txt
ECHO 888-55-4321 > file.txt:secret
DIR file.txt
TYPE file.txt
MORE < file.txt:secret
NOTEPAD file.txt:secret
DIR /R file.txt
TYPE file.txt:secret
MKDIR kids
ECHO top-secret-information-going-here > kids:hidden
DIR /R
MORE < kids:hidden
Get-Content file.txt -Stream secret


#Insert a script into an ADS! (this one pings Google)
Write-Output "Nothing to see here!" > notes.txt
Add-Content -Path .\notes.txt -Value 'Dim oShell' -Stream 'cantseeme.vbs'
Add-Content -Path .\notes.txt -Value 'Set oShell = Wscript.CreateObject ("Wscript.Shell")' -Stream 'cantseeme.vbs'
Add-Content -Path .\notes.txt -Value 'oShell.run "cmd /k CD C:\Program Files & ping 8.8.8.8" ,1 , true ' -Stream 'cantseeme.vbs'
Get-Content .\notes.txt
Get-Content .\notes.txt -Stream cantseeme.vbs
wscript .\notes.txt:cantseeme.vbs
Certutil -hashfile notes.txt MD5
notepad notes.txt:cantseeme.vbs
# Add any lines of text to the end of the file that you like
notepad notes.txt:cantseeme.vbs
Certutil -hashfile notes.txt MD5

#endregion Alternate Data Streams